{$IFDEF NOPE}
program IzravnavanjeHistograma;
const MaxSirina = 200; MaxVisina = 200;
var 
  T: text;
  Slika: array [0..MaxVisina - 1, 0..MaxSirina - 1] of integer;
  Hist, CiljHist, Nova, NovaKoliko: array [0..255] of integer; 
  x, y, b, nb, n, nn, Sirina, Visina: integer;
begin
  { Preberimo vhodno sliko. }
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'histogrami.in');
  Reset(T); ReadLn(T, Visina, Sirina);
  Assert(1 <= Sirina); Assert(Sirina <= MaxSirina);
  Assert(1 <= Visina); Assert(Visina <= MaxVisina);
  for y := 0 to Visina - 1 do for x := 0 to Sirina - 1 do Read(T, Slika[y, x]);
  Close(T);

  { Izraunajmo histogram prvotne slike. }
  for b := 0 to 255 do Hist[b] := 0;
  for y := 0 to Visina - 1 do for x := 0 to Sirina - 1 do
    Hist[Slika[y, x]] := Hist[Slika[y, x]] + 1;
  if false then begin { Tale izpis lahko vtaknemo v rtk05-histogrami.ps. }
    Write('[');
    for b := 0 to 255 do Write(' ' , Hist[b]);
    WriteLn(' ]'); 
  end; {if}

  { V tabeli CiljHist pripravimo enega od monih histogramov nove slike. 
    Druge mone histograme, ki bi tudi ustrezali zahtevam naloge,
    bi lahko dobili tako, da bi druga zanka poveala za 1 kakne
    druge elemente, ne pa ravno prvih nekaj. }
  for b := 0 to 255 do CiljHist[b] := (Sirina * Visina) div 256;
  for b := 0 to ((Sirina * Visina) mod 256) - 1 do CiljHist[b] := CiljHist[b] + 1;
  
  { Vsaka barva prvotne slike se preslika v eno ali ve zaporednih
    barv nove slike.  Izraunajmo za zaetek najtemnejo barvo Nova[b],
    v katero se bo preslikala posamezna barva b prvotne slike, pa e
    to, koliko pikslov barve b se bo preslikalo v barvo Nova[b]. }
  n := 0; nn := 0; nb := 0;
  for b := 0 to 255 do if Hist[b] > 0 then begin
    { n je tevilo pikslov, ki imajo v prvotni sliki barvo < b,
      nb pa tevilo pikslov, ki imajo v novi sliki barvo < nb. }
    while nn + CiljHist[nb] <= n do begin nn := nn + CiljHist[nb]; nb := nb + 1 end;
    Nova[b] := nb;
    NovaKoliko[b] := nn + CiljHist[nb] - n;
    if NovaKoliko[b] > Hist[b] then NovaKoliko[b] := Hist[b];
    n := n + Hist[b];
  end; {for b}
  
  { Pojdimo po sliki in popravljajmo barve pikslov.  Barva b
    na stari sliki postane barva Nova[b] na novi sliki.  e pa
    ima ta barva e dovolj pikslov, zanimo uporabljati naslednjo. }
  for y := 0 to Visina - 1 do for x := 0 to Sirina - 1 do begin
    b := Slika[y, x];
    if NovaKoliko[b] = 0 then begin Nova[b] := Nova[b] + 1; NovaKoliko[b] := CiljHist[Nova[b]] end;
    Slika[y, x] := Nova[b]; NovaKoliko[b] := NovaKoliko[b] - 1;
  end; {for x, y}

  { Izpiimo rezultat. }
  if ParamCount > 1 then Assign(T, ParamStr(2)) else Assign(T, 'histogrami.out');
  Rewrite(T);
  for y := 0 to Visina - 1 do for x := 0 to Sirina - 1 do begin 
    Write(T, Slika[y, x]); if x = Sirina - 1 then WriteLn(T) else Write(T, ' ');
  end; {for x, y}
  Close(T);
end. {IzravnavanjeHistograma}
{$ENDIF}

program IzravnavanjeHistograma;
const MaxSirina = 200; MaxVisina = 200;
var 
  T: text;
  Slika: array [0..MaxVisina - 1, 0..MaxSirina - 1] of integer;
  Hist, CiljHist, Nova, NovaKoliko: array [0..255] of integer; 
  x, y, c, cNova, Koliko, Sirina, Visina: integer;
begin
  { Preberimo vhodno sliko. }
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'histogrami.in');
  Reset(T); ReadLn(T, Visina, Sirina);
  Assert(1 <= Sirina); Assert(Sirina <= MaxSirina);
  Assert(1 <= Visina); Assert(Visina <= MaxVisina);
  for y := 0 to Visina - 1 do for x := 0 to Sirina - 1 do Read(T, Slika[y, x]);
  Close(T);

  { Izraunajmo histogram prvotne slike. }
  for c := 0 to 255 do Hist[c] := 0;
  for y := 0 to Visina - 1 do for x := 0 to Sirina - 1 do
    Hist[Slika[y, x]] := Hist[Slika[y, x]] + 1;
  if false then begin { Tale izpis lahko vtaknemo v rtk05-histogrami.ps. }
    Write('[');
    for c := 0 to 255 do Write(' ' , Hist[c]);
    WriteLn(' ]'); 
  end; {if}

  { V tabeli CiljHist pripravimo enega od monih histogramov nove slike. 
    Druge mone histograme, ki bi tudi ustrezali zahtevam naloge,
    bi lahko dobili tako, da bi druga zanka poveala za 1 kakne
    druge elemente, ne pa ravno prvih nekaj. }
  for c := 0 to 255 do CiljHist[c] := (Sirina * Visina) div 256;
  for c := 0 to ((Sirina * Visina) mod 256) - 1 do CiljHist[c] := CiljHist[c] + 1;
  
  { Vsaka barva prvotne slike se preslika v eno ali ve zaporednih
    barv nove slike.  Izraunajmo za zaetek najtemnejo barvo Nova[c],
    v katero se bo preslikala posamezna barva c prvotne slike, pa e
    to, koliko pikslov barve c se bo preslikalo v barvo Nova[c]. }
  cNova := 0; Koliko := CiljHist[cNova];
  for c := 0 to 255 do {if Hist[c] > 0 then} begin
    Nova[c] := cNova; NovaKoliko[c] := Koliko;
    Koliko := Koliko - Hist[c];
    while (Koliko <= 0) and (cNova < 255) do
      begin cNova := cNova + 1; Koliko := Koliko + CiljHist[cNova] end;
  end; {for c}
  
  { Pojdimo po sliki in popravljajmo barve pikslov.  Barva c
    na stari sliki postane barva Nova[c] na novi sliki.  e pa
    ima ta barva e dovolj pikslov, zanimo uporabljati naslednjo. }
  for y := 0 to Visina - 1 do for x := 0 to Sirina - 1 do begin
    c := Slika[y, x];
    while NovaKoliko[c] = 0 do begin Nova[c] := Nova[c] + 1; NovaKoliko[c] := CiljHist[Nova[c]] end;
    Slika[y, x] := Nova[c]; NovaKoliko[c] := NovaKoliko[c] - 1;
  end; {for x, y}

  { Izpiimo rezultat. }
  if ParamCount > 1 then Assign(T, ParamStr(2)) else Assign(T, 'histogrami.out');
  Rewrite(T);
  for y := 0 to Visina - 1 do for x := 0 to Sirina - 1 do begin 
    Write(T, Slika[y, x]); if x = Sirina - 1 then WriteLn(T) else Write(T, ' ');
  end; {for x, y}
  Close(T);
end. {IzravnavanjeHistograma}
